<?php namespace EscapeWork\Manager\Commands\Role;

use Illuminate\Contracts\Bus\SelfHandling;
use EscapeWork\Manager\Commands\Command;
use EscapeWork\Manager\Models\Role;
use EscapeWork\Manager\Models\RolePage;
use EscapeWork\Manager\Http\Requests\Role\FormRequest;

class SaveRoleCommand extends Command implements SelfHandling
{

    /**
     * Create a new command instance.
     *
     * @return void
     */
    public function __construct()
    {

    }

    /**
     * Execute the command.
     *
     * @return void
     */
    public function handle(FormRequest $request, Role $role)
    {
        if ($request->id) {
            $role = $role->findOrFail($request->id);
        }

        $role->fill($request->all());
        $role->save();

        /**
         * Deleting related pages to save them later
         */
        $role->pages()->delete();

        /**
         * Saving pages related to @role
         */
        $pages = [];
        foreach ((array) $request->get('pages') as $page) {
            array_push($pages, new RolePage([ 'page' => $page ]));
        }

        $role->pages()->saveMany($pages);

        // $request->get('actions')

        return $role;
    }
}
