<?php namespace EscapeWork\Manager\Commands\Users;

use EscapeWork\Manager\Commands\Command;
use EscapeWork\Manager\Models\User;
use EscapeWork\Manager\Models\Role;

use Illuminate\Contracts\Bus\SelfHandling;

class UserCreateCommand extends Command implements SelfHandling
{

    /**
     * @var array
     */
    protected $data;

    public function __construct($data)
    {
        $this->data = (array) $data;
    }

    /**
     * Execute the command.
     *
     * @return void
     */
    public function handle(User $user)
    {
        if (! $user->role_id) {
            $user->role_id = Role::getDefault()->id;
        }

        $user->fill($this->data);
        $user->save();

        return $user;
    }
}
