<?php namespace EscapeWork\Manager\Commands\Users;

use EscapeWork\Manager\Commands\Command;
use EscapeWork\Manager\Models\User;

use Illuminate\Contracts\Bus\SelfHandling;

class UserUpdateCommand extends Command implements SelfHandling
{

    /**
     * @var int
     */
    protected $id;

    /**
     * @var array
     */
    protected $data;

    public function __construct($id, $data)
    {
        $this->id   = $id;
        $this->data = (array) $data;
    }

    /**
     * Execute the command.
     *
     * @return void
     */
    public function handle(User $user)
    {
        $user = $user->findOrFail($this->id);

        $user->fill($this->data);
        $user->save();

        return $user;
    }
}
