<?php namespace EscapeWork\Manager\Console;

use Symfony\Component\Console\Input\InputOption;

class CommandMakeCommand extends GeneratorCommand
{

    /**
     * The console command name.
     *
     * @var string
     */
    protected $name = 'manager:make:command';

    /**
     * The console command description.
     *
     * @var string
     */
    protected $description = 'Create a new command class';

    /**
     * The type of class being generated.
     *
     * @var string
     */
    protected $type = 'Command';

    /**
     * Get the stub file for the generator.
     *
     * @return string
     */
    protected function getStub()
    {
        return __DIR__.'/../../resources/stubs/command-'.$this->option('type').'.stub';
    }

    /**
     * Get the default namespace for the class.
     *
     * @param  string  $rootNamespace
     * @return string
     */
    protected function getDefaultNamespace($rootNamespace)
    {
        return $rootNamespace.'\Commands\\' . $this->argument('subnamespace');
    }

    public function replaceSpecific($stub, $name)
    {
        $stub = str_replace('{{model}}', $this->option('model'), $stub);

        return $stub;
    }

    public function getOptions()
    {
        return [
            ['model', null, InputOption::VALUE_REQUIRED, 'The model'],
            ['type', null, InputOption::VALUE_REQUIRED, 'The type (create, update or destroy)'],
        ];
    }
}
