<?php namespace EscapeWork\Manager\Console;

use Symfony\Component\Console\Input\InputOption;

class ModelMakeCommand extends GeneratorCommand {

    /**
     * The console command name.
     *
     * @var string
     */
    protected $name = 'manager:make:model';

    /**
     * The console command description.
     *
     * @var string
     */
    protected $description = 'Create a new Eloquent model class';

    /**
     * The type of class being generated.
     *
     * @var string
     */
    protected $type = 'Model';

    /**
     * Get the stub file for the generator.
     *
     * @return string
     */
    protected function getStub()
    {
        return __DIR__.'/../../resources/stubs/model.stub';
    }

    /**
     * Get the default namespace for the class.
     *
     * @param  string  $rootNamespace
     * @return string
     */
    protected function getDefaultNamespace($rootNamespace)
    {
        return $rootNamespace.'\Models';
    }

    public function replaceSpecific($stub, $name)
    {
        $stub = str_replace('{{table}}', $this->option('table'), $stub);

        return $stub;
    }

    public function getOptions()
    {
        return [
            ['table', null, InputOption::VALUE_REQUIRED, 'The table']
        ];
    }
}
