<?php namespace EscapeWork\Manager\Console;

use Symfony\Component\Console\Input\InputOption;

class RequestMakeCommand extends GeneratorCommand
{

    /**
     * The console command name.
     *
     * @var string
     */
    protected $name = 'manager:make:request';

    /**
     * The console command description.
     *
     * @var string
     */
    protected $description = 'Create a new form request class';

    /**
     * The type of class being generated.
     *
     * @var string
     */
    protected $type = 'Request';

    /**
     * Get the stub file for the generator.
     *
     * @return string
     */
    protected function getStub()
    {
        return __DIR__.'/../../resources/stubs/request-'.$this->option('type').'.stub';
    }

    /**
     * Get the default namespace for the class.
     *
     * @param  string  $rootNamespace
     * @return string
     */
    protected function getDefaultNamespace($rootNamespace)
    {
        return $rootNamespace.'\Http\Requests\\' . $this->argument('subnamespace');
    }

    public function getOptions()
    {
        return [
            ['type', null, InputOption::VALUE_REQUIRED, 'The type (create or update)'],
        ];
    }
}
