<?php namespace EscapeWork\Manager\Http\Controllers;

use Illuminate\Foundation\Bus\DispatchesCommands;
use Illuminate\Routing\Controller as BaseController;
use Illuminate\Foundation\Validation\ValidatesRequests;
use View, ReflectionClass;

abstract class Controller extends BaseController
{

    use DispatchesCommands, ValidatesRequests;

    public function __construct()
    {
        $this->_setPageName();
    }

    protected function _setPageName()
    {
        $reflection = new ReflectionClass($this);
        View::share('page', strtolower(str_replace('Controller', '', $reflection->getShortName())));
    }
}
