<?php namespace EscapeWork\Manager\Http\Middleware;

use EscapeWork\Manager\Extensions\Auth\Guard;
use Closure;

class UnauthorizeIfGuest {

    /**
     * Create a new filter instance.
     *
     * @param  Guard  $auth
     * @return void
     */
    public function __construct(Guard $auth)
    {
        $this->auth = $auth;
    }

    /**
     * Run the request filter.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  \Closure  $next
     * @return mixed
     */
    public function handle($request, Closure $next)
    {
        if (! $this->auth->guest()) {
            if ($request->ajax()) {
                return response('Unauthorized.', 401);
            }

            return redirect()->guest(route('manager.home'));
        }
        return $next($request);
    }

}
